/*
 * Project: MoleCuilder
 * Description: creates and alters molecular systems
 * Copyright (C)  2010-2012 University of Bonn. All rights reserved.
 * Copyright (C)  2013 Frederik Heber. All rights reserved.
 * 
 *
 *   This file is part of MoleCuilder.
 *
 *    MoleCuilder is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    MoleCuilder is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with MoleCuilder.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * RandomNumberDistribution_ParametersCommandLineQuery.cpp
 *
 *  Created on: Jan 06, 2011
 *      Author: heber
 */

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "CodePatterns/MemDebug.hpp"

#include <iostream>
#include <sstream>
#include <string>

#include "CommandLineUI/Query/CommandLineQuery.hpp"
#include "CommandLineUI/CommandLineParser.hpp"
#include "CodePatterns/Log.hpp"
#include "CodePatterns/Verbose.hpp"

#include "RandomNumbers/RandomNumberDistribution_Parameters.hpp"

CommandLineDialog::RandomNumberDistribution_ParametersCommandLineQuery::RandomNumberDistribution_ParametersCommandLineQuery(Parameter<RandomNumberDistribution_Parameters> &_param, const std::string &_title, const std::string &_description) :
    Dialog::TQuery<RandomNumberDistribution_Parameters>(_param, _title, _description)
{}

CommandLineDialog::RandomNumberDistribution_ParametersCommandLineQuery::~RandomNumberDistribution_ParametersCommandLineQuery() {}

bool CommandLineDialog::RandomNumberDistribution_ParametersCommandLineQuery::handle() {
  std::string stringtext;
  if (CommandLineParser::getInstance().vm.count(getTitle())) {
    try {
      stringtext = CommandLineParser::getInstance().vm[getTitle()].as<std::string>();
    } catch(boost::bad_any_cast &e) {
      stringtext = std::string("");
      return false;
    }
    std::stringstream text(stringtext);
//    LOG(1, "INFO: Parameter set from CommandLine is '" << text.str() << "'");
    text >> temp;
    return true;
  }
  return false;
}

